searchNodes=[{"doc":"Telemetría is the opinionated wrapper for :telemetry providing handy macros to attach telemetry events to any function, private function, anonymous functions (on per-clause basis) and just random set of expressions.Telemetría exports three macros:deft/2 which is wrapping Kernel.def/2defpt/2 which is wrapping Kernel.defp/2t/2 which is wrapping the expression passed as the first parameter and adds the options passed as a keyword to the second parameter to the context of the respective telemetry eventTelemetría allows compile-time telemetry events definition and provides a compiler that is responsible for incremental builds and updates of the list of events telemetry is aware about.AdvantagesTelemetría takes care about managing events in the target application, makes it a single-letter change to turn a function into a function wrapped with telemetry call, measuring the execution time out of the box.It also allows to easily convert expressions to be be telemetry-aware.Besides that, telemetry: false flag allows to purge the calls in compile-time resulting in zero overhead (useful for benchmark, or like.)ExampleYou need to include the compiler in mix.exs:defmodule MyApp.MixProject do def project do [ # ... compilers: [:telemetria | Mix.compilers()], # ... ] end # ... endIn the modules you want to add telemetry to, you should require Telemetria (or, preferably, import Telemetria to make it available without FQN.) Once imported, the macros are available and tracked by the compiler.defmodule MyMod do import Telemetria defpt pi, do: 3.14 deft answer, do: 42 - pi() def inner do short_result = t(42 * 42) result = t do # long calculations :ok end end endUse in releases:telemetria compiler keeps track of the events in the compiler manifest file to support incremental builds. Also it spits out config/.telemetria.config.json config for convenience. It might be used in in the release configuration as shown below.releases: [ configured: [ # ..., config_providers: [{Telemetria.ConfigProvider, &quot;/etc/telemetria.json&quot;}] ] ]Options:otp_app - OTP application this telemetry is attached to. The default value is :telemetria.:enabled - Specifies whether telemetry should be enabled. The default value is true.:json_config_path - Relative path to JSON config The default value is &quot;config/.telemetria.config.json&quot;.:events - The application-specific events.See :telemetry.event_prefix/0 and :telemetry.event_name/0. The default value is [].:handler - Event handler for this application’s telemetry events. Arity must be 4. The default value is {Telemetria.Handler.Default, :handle_event}.:polling - The default value is [enabled: false, flush: 5000, poll: 5000].:enabled - Specifies whether polling should be enabled. The default value is true.:flush - Flush interval. The default value is 5000.:poll - Poll interval. The default value is 5000.","ref":"Telemetria.html","title":"Telemetria","type":"module"},{"doc":"Declares a private function with a telemetry attached, measuring execution time","ref":"Telemetria.html#defpt/2","title":"Telemetria.defpt/2","type":"macro"},{"doc":"Declares a function with a telemetry attached, measuring execution time","ref":"Telemetria.html#deft/2","title":"Telemetria.deft/2","type":"macro"},{"doc":"Attaches telemetry to anonymous function (per clause,) or to expression(s)","ref":"Telemetria.html#t/2","title":"Telemetria.t/2","type":"macro"},{"doc":"","ref":"Telemetria.html#telemetry_wrap/4","title":"Telemetria.telemetry_wrap/4","type":"function"},{"doc":"Default handler used unless the custom one is specified in config.This handler collects event, measurements, metadata, and config, packs them into the keyword list and logs on :info log level.","ref":"Telemetria.Handler.Default.html","title":"Telemetria.Handler.Default","type":"module"},{"doc":"","ref":"Test.Telemetria.S.html","title":"Test.Telemetria.S","type":"module"},{"doc":"The behaviour to be implemented by consumers.Telemetría provides the default handler, that simply delegates to Logger.info/1.See: Telemetria.Handler.Default.","ref":"Telemetria.Handler.html","title":"Telemetria.Handler","type":"behaviour"},{"doc":"The callback that will be invoked by :telemetry","ref":"Telemetria.Handler.html#c:handle_event/4","title":"Telemetria.Handler.handle_event/4","type":"callback"},{"doc":"","ref":"Telemetria.Error.html","title":"Telemetria.Error","type":"exception"},{"doc":"Telemetría    The helper application that simplifies and standardizes telemetry usage.","ref":"readme.html","title":"Telemetría","type":"extras"},{"doc":"def project do [ compilers: [:telemetria | Mix.compilers()] ] end def deps do [ {:telemetria, &quot;~&gt; 0.1&quot;} ] end","ref":"readme.html#installation","title":"Telemetría - Installation","type":"extras"},{"doc":"0.7.0 —[ENH] add named arguments in all calls to event’s context0.6.1 —[BUG] wrong order using telemetry with many clauses0.6.0 —[ENH] accept parameters in annotation @telemetria[MIN] better print of events added0.5.2 —[ENH] enabled: false config to purge all telemetria code at once0.5.1 —[ENH] add result of underlying call to metric[ENH] decrease an amount of garbage returned from caller context0.5.0 —[ENH] annotation @telemetria true as a synonym to deft/2[FIX] polling is off by default0.4.0 —[ENH] default polling of system / vm states for free[ENH] starting in phases ensuring proper instrumenter setup0.3.0 —[ENH] no need for any config in any environment[BUG] proper handling of guards in compiler, correct event names","ref":"readme.html#changelog","title":"Telemetría - Changelog","type":"extras"},{"doc":"","ref":"readme.html#documentation","title":"Telemetría - Documentation.","type":"extras"}]